%bcond_with static
%bcond_with libr

%define arch_has_java 1
%ifarch %arm %mips
%define arch_has_java 0
%endif

%define cdt_major 5
%define cgraph_major 6
%define graph_major 5
%define gvc_major 6
%define gvpr_major 2
%define pathplan_major 4
%define xdot_major 4

%define lib_cdt %mklibname cdt %{cdt_major}
%define lib_cgraph %mklibname cgraph %{cgraph_major}
%define lib_graph %mklibname graph %{graph_major}
%define lib_gvc %mklibname gvc %{gvc_major}
%define lib_gvpr %mklibname gvpr %{gvpr_major}
%define lib_pathplan %mklibname pathplan %{pathplan_major}
%define lib_xdot %mklibname xdot %{xdot_major}
%define develname %mklibname graphviz -d
%define staticname %mklibname graphviz -d -s

Summary:	Graph visualization tools
Name:		graphviz
Version:	2.28.0
Release:	%mkrel 11
Group:		Graphics/Utilities
License:	Common Public License
URL:		http://www.graphviz.org
Source:		http://www.graphviz.org/pub/graphviz/ARCHIVE/%{name}-%{version}.tar.gz
Patch0:		graphviz-2.28.0-linkage.patch
Patch1:		graphviz-ocaml-4.patch
Patch2:		graphviz-2.26.0-rtest-errout-fix.patch
Patch3:		graphviz-2.28.0-guile-detect.patch
Patch4:		graphviz-2.28.0-fix-format-errors.patch
Patch5:		graphviz-2.26.0-testsuite-sigsegv-fix.patch
Patch6:		graphviz-2.28.0-ruby1.9.patch
BuildRequires:	bison >= 2.3
BuildRequires:	flex >= 2.5.4a
BuildRequires:	swig >= 1.3.29
BuildRequires:	freetype2-devel >= 2.1.10
BuildRequires:	pango-devel >= 1.12.4
BuildRequires:	gd-devel >= 2.0.34
BuildRequires:	gettext-devel >= 0.14.5
BuildRequires:	libcurl-devel
BuildRequires:	libjpeg-devel
BuildRequires:	libtool
BuildRequires:	libltdl-devel
BuildRequires:	libpng-devel >= 1.2.10
BuildRequires:	librsvg-devel
BuildRequires:	libx11-devel
BuildRequires:	libxaw-devel
BuildRequires:	libxmu-devel
BuildRequires:	libxt-devel
BuildRequires:	gtk+2-devel
BuildRequires:	gtkglarea2-devel
BuildRequires:	gtkglext-devel
BuildRequires:	zlib-devel >= 1.2.3
BuildRequires:	libexpat-devel >= 2.0.0
BuildRequires:	libfontconfig-devel >= 2.3.95
Conflicts: %{mklibname graphviz 4} < 2.20.3-3

%description
A collection of tools for the manipulation and layout
of graphs (as in nodes and edges, not as in barcharts).


%files
%dir %{_libdir}/%{name}
%{_bindir}/*
%_mandir/man?/*
%{_datadir}/graphviz
%{_libdir}/graphviz/*.so.*

#-------------------------------------------------------------------------

%package doc
Group:		Documentation
Summary:	%{name} documentation
BuildArch:	noarch

%description doc
The %{name} documentation.


%files doc
%{_datadir}/doc/%{name}

#-------------------------------------------------------------------------

%package -n %{lib_cdt}
Group:		System/Libraries
Summary:	Shared library for %{name}
Conflicts:	%{_lib}graphviz4 < 2.26

%description -n %{lib_cdt}
This package provides the cdt shared library for %{name}.


%files -n %{lib_cdt}
%{_libdir}/libcdt.so.%{cdt_major}*

#-------------------------------------------------------------------------

%package -n %{lib_cgraph}
Group:		System/Libraries
Summary:	Shared library for %{name}
Conflicts:	%{_lib}graphviz4 < 2.26

%description -n %{lib_cgraph}
This package provides the cgraph shared library for %{name}.


%files -n %{lib_cgraph}
%{_libdir}/libcgraph.so.%{cgraph_major}*

#-------------------------------------------------------------------------

%package -n %{lib_graph}
Group:		System/Libraries
Summary:	Shared library for %{name}
Conflicts:	%{_lib}graphviz4 < 2.26
Obsoletes:	%{_lib}graphviz4 < 2.26

%description -n %{lib_graph}
This package provides the graph shared library for %{name}.


%files -n %{lib_graph}
%{_libdir}/libgraph.so.%{graph_major}*

#-------------------------------------------------------------------------

%package -n %{lib_gvc}
Group:		System/Libraries
Summary:	Shared library for %{name}
Conflicts:	%{_lib}graphviz4 < 2.26

%description -n %{lib_gvc}
This package provides the gvc shared library for %{name}.

%files -n %{lib_gvc}
%{_libdir}/libgvc.so.%{gvc_major}*

#-------------------------------------------------------------------------

%package -n %{lib_gvpr}
Group:		System/Libraries
Summary:	Shared library for %{name}

%description -n %{lib_gvpr}
This package provides the gvpr shared library for %{name}.

%files -n %{lib_gvpr}
%{_libdir}/libgvpr.so.%{gvpr_major}*

#-------------------------------------------------------------------------

%package -n %{lib_pathplan}
Group:		System/Libraries
Summary:	Shared library for %{name}
Conflicts:	%{_lib}graphviz4 < 2.26

%description -n %{lib_pathplan}
This package provides the pathplan shared library for %{name}.

%files -n %{lib_pathplan}
%{_libdir}/libpathplan.so.%{pathplan_major}*

#-------------------------------------------------------------------------

%package -n %{lib_xdot}
Group:		System/Libraries
Summary:	Shared library for %{name}

%description -n %{lib_xdot}
This package provides the xdot shared library for %{name}.

%files -n %{lib_xdot}
%{_libdir}/libxdot.so.%{xdot_major}*

#-------------------------------------------------------------------------
# (kamil) something is pulling liblua 5.1.5, so temporarily build against liblua 5.1.5
%define lua_version 5.1
#define lua_version %(if [ -x /usr/bin/lua ]; then lua -v 2>&1| awk '{print $2}' | awk -F. '{print $1 "." $2}'; fi)

%package -n lua-graphviz
Group:		System/Libraries
Summary:	Graphviz bindings for lua
BuildRequires:  lua5.1-devel
BuildRequires:	lua5.1
Obsoletes: %{mklibname graphvizlua 0}

%description -n lua-graphviz
This package provides the Lua extension for %{name}.

%files -n lua-graphviz
%{_libdir}/graphviz/lua
%{_libdir}/lua/%{lua_version}/gv.so

#-------------------------------------------------------------------------

%package  -n php-graphviz
Group:		System/Libraries
Summary:	Graphviz bindings for php
BuildRequires: php-devel
BuildRequires: php-cli
Obsoletes: %{mklibname graphvizphp 0}

%description -n php-graphviz
This package provides the PHP extension for %{name}.

%files -n php-graphviz
%{_libdir}/graphviz/php
%{_libdir}/php/modules/gv.so
%{_datadir}/php/gv.php

#-------------------------------------------------------------------------

%package -n python-graphviz
Group: System/Libraries
Summary: Graphviz bindings for python
Obsoletes: %{mklibname graphvizpython 0}
BuildRequires: python-devel

%description -n python-graphviz
This package provides the Python extension for %{name}.

%files -n python-graphviz
%{_libdir}/graphviz/python
%py_platsitedir/*

#-------------------------------------------------------------------------

%package -n ruby-graphviz
Group: System/Libraries
Summary: Graphviz bindings for ruby
BuildRequires: ruby-devel
Obsoletes: %{mklibname graphvizruby 0}

%description -n ruby-graphviz
This package provides the Ruby extension for %{name}.

%files -n ruby-graphviz
%{_libdir}/graphviz/ruby
%ruby_sitearchdir/*

#-------------------------------------------------------------------------

%package -n perl-graphviz
Group:		System/Libraries
Summary:	Graphviz bindings for perl
BuildRequires:	perl-devel
Obsoletes: %{mklibname graphvizperl 0}

%description -n perl-graphviz
This package provides the Perl extension for %{name}.


%files -n perl-graphviz
%{perl_vendorarch}/*
%{_libdir}/graphviz/perl

#-------------------------------------------------------------------------

%package -n tcl-graphviz
Group: System/Libraries
Summary: Graphviz bindings for tcl
BuildRequires:	tcl-devel >= 8.3.0
BuildRequires:	tk-devel >= 8.3.0
BuildRequires:	tk >= 8.3.0
Obsoletes: %{mklibname graphviztcl 7 -d}
Obsoletes: %{mklibname graphviztcl 0}

%description -n tcl-graphviz
This package provides the Tcl extension for %{name}.


%files -n tcl-graphviz
%{_libdir}/tcl*
%{_libdir}/graphviz/tcl

#-------------------------------------------------------------------------
%if %arch_has_java
%define jdk_path %{_prefix}/lib/jvm/java
%define java_includes %{_includedir}/libgcj

%package -n java-graphviz
Group:		System/Libraries
Summary:	Graphviz bindings for java
BuildRequires:	java-devel
Obsoletes: %{mklibname graphvizjava 0}

%description -n java-graphviz
This package provides the Java extension for %{name}.


%files -n java-graphviz
%{_libdir}/graphviz/java
%endif
#-------------------------------------------------------------------------
%if %with libr

%package -n r-graphviz
Group:		System/Libraries
Summary:	Graphviz bindings for R
BuildRequires:	libRmath-devel
Obsoletes: %{mklibname graphvizr 0}

%description -n r-graphviz
This package provides the R extension for %{name}.


%files -n r-graphviz
%{_libdir}/graphviz/R

%endif
#-------------------------------------------------------------------------

%package -n ocaml-graphviz
Group:		System/Libraries
Summary:	Graphviz bindings for OCaml
BuildRequires:	ocaml
Obsoletes: %{mklibname graphvizocaml 0}

%description -n ocaml-graphviz
This package provides the OCaml extension for %{name}.


%files -n ocaml-graphviz
%{_libdir}/graphviz/ocaml

#-------------------------------------------------------------------------

%define oldmajor 3

%package -n %{develname}
Group:		Development/Other
Summary:	Development package for %{name}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{mklibname graphviz -d 7}
Obsoletes:	%{mklibname graphviztcl -d 7}
Obsoletes:	%{mklibname -d %name %oldmajor}
Requires:	%{lib_cdt} = %{version}
Requires:	%{lib_cgraph} = %{version}
Requires:	%{lib_graph} = %{version}
Requires:	%{lib_gvc} = %{version}
Requires:	%{lib_gvpr} = %{version}
Requires:	%{lib_pathplan} = %{version}
Requires:	%{lib_xdot} = %{version}
Requires:	%{name} = %{version}

%description -n %{develname}
Development package for %{name}.


%files -n %{develname}
%{_libdir}/pkgconfig/*
%{_libdir}/graphviz/*.so
%{_libdir}/*.so
%{_includedir}/graphviz

#-------------------------------------------------------------------------

%if ! %without static
%package -n %{staticname}
Group:		Development/Other
Summary:	Static development package for %{name}
Requires:	%{develname} = %{version}-%{release}
Provides:	%{name}-static-devel = %{version}-%{release}
Obsoletes:	%mklibname -d -s %name %oldmajor

%description -n %{staticname}
Static development package for %{name}.


%files -n %{staticname}
%{_libdir}/graphviz/*.a
%{_libdir}/*.a

%endif

#-------------------------------------------------------------------------

%prep
%setup -q
%apply_patches

%build
export LUA=lua5.1
%configure2_5x \
	--with-x \
%if %without static
	 --disable-static \
%else
	--enable-static \
%endif
%if %with libr
	--enable-r \
%else
	--disable-r \
%endif
	--enable-ocaml \
	--enable-perl \
	--enable-php \
	--enable-python \
	--disable-guile \
	--disable-sharp \
	--with-pangocairo \
	--with-gtk \
	--enable-tcl=yes --with-tclsh=%{_bindir}/tclsh --with-wish=%{_bindir}/wish \
	--with-libgd \
	--disable-io \
	--disable-dependency-tracking

%make TCL_LIBS=-ltcl

%install
%makeinstall_std

find %{buildroot} -name '*.la' -delete

# fix documentation
install -d -m 755 %{buildroot}%{_docdir}
mv %{buildroot}%{_datadir}/%{name}/doc %{buildroot}%{_docdir}/%{name}
mv %{buildroot}%{_datadir}/%{name}/demo %{buildroot}%{_docdir}/%{name}

%post
%{_bindir}/dot -c

%postun
if ! test -x %{_bindir}/dot; then rm -f %{_libdir}/%{name}/config; fi


%changelog

* Sat Jan 12 2013 umeabot <umeabot> 2.28.0-11.mga3
+ Revision: 352580
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

  + boklm <boklm>
    - Update group: Graphics/Other -> Graphics/Utilities

* Mon Nov 05 2012 fwang <fwang> 2.28.0-10.mga3
+ Revision: 314352
- use env rather patch

* Mon Nov 05 2012 fwang <fwang> 2.28.0-9.mga3
+ Revision: 314348
- update tcl link patch
- disable static build

* Mon Nov 05 2012 fwang <fwang> 2.28.0-8.mga3
+ Revision: 314295
- update file list
- correct tclswitch
- enable tcl
- specify tclpath
- br lua5.1
- build with lua
- recognize correct rubydir
- more linkage fix
- fix linkage
- recognize ruby1.9 dir
- use autoreconf
- sync with fedora patches
- rebuild for new ruby

  + ennael <ennael>
    - fix Graphics group
    - Documentation group

  + kamil <kamil>
    - temporarily build against lua 5.1.x
    - bump release
    - clean .spec

* Wed May 30 2012 jquelin <jquelin> 2.28.0-5.mga3
+ Revision: 250911
- perl 5.16 rebuild

* Wed Dec 28 2011 rtp <rtp> 2.28.0-4.mga2
+ Revision: 188387
- add back arm/mips fix from r39919, which got dropped by commit 115011

* Sun Dec 04 2011 fwang <fwang> 2.28.0-3.mga2
+ Revision: 176242
- real fix on linkage
- more linkage fix
- doc is a non-arch package

* Thu Sep 22 2011 fwang <fwang> 2.28.0-2.mga2
+ Revision: 146604
- fix linkage
- drop .la files

* Tue Jun 28 2011 fwang <fwang> 2.28.0-1.mga2
+ Revision: 115011
- new version 2.28.0

* Sun Jun 12 2011 sander85 <sander85> 2.26.3-8.mga2
+ Revision: 104631
- Rebuild for perl 5.14

  + rtp <rtp>
    - disable java on arm/mips

* Wed Jan 19 2011 jquelin <jquelin> 2.26.3-7.mga1
+ Revision: 23789
- rebuild

* Mon Jan 17 2011 misc <misc> 2.26.3-6.mga1
+ Revision: 21544
- rebuilt for python 2.7
- remove versionning of buildRequires that goes back to mandriva 2008.0

* Fri Jan 14 2011 mikala <mikala> 2.26.3-5.mga1
+ Revision: 17946
- imported package graphviz

